//Homework 8
//Carlos Rios
//Collaboration Statement: I worked on this homework problem using outside internet sources.

/**
* This program implements a model representing the state of all the cells in 
* "The Game of Life". Implements the rules that determine how the cells 
* change for each iteration of the game and returns an array of squares 
* that represent the state of the cells after each iteration.
* 
* @author Carlos Rios
* @version 1.0
*/

public class CellModel

{	/** 
	* modelCurrent contains the state of all cells in the current array 
	*/
	boolean[][] modelCurrent = new boolean[20][20];
	
	/**
	* modelNext contains the state of all cells after the game is iterated 
	*/
	boolean[][] modelNext = new boolean[20][20];

   /**
   * the constructor CellModel doesn't do any initialization
   */
	public CellModel()
	{
	}
	
   /**
   * initializeModel initializes the current cell model usng the array of squares from the user interface
   * @param squares An array of squares derived from the user interface.
   */	
	public void initializeModel(Square[] squares)
	{	
		
		for(int i=0;i<20;i++)
			{for(int j=0;j<20;j++)
				{
					modelCurrent[i][j]=squares[(i*20)+j].getState();
					
				}
			}	
					
	}

   /**
   * step calculates the state of the next cell model when the current cell model is iterated with the transformation rules
   * @return  An array of squares that represent the graphical view of the iterated model
   */
	public Square[] step()
	{
	Square[] squareOut= new Square[400];
	int count;
	for (int i=0;i<400;i++)
	squareOut[i]=new Square();
	// the cell rules are implemented
	for (int j=0;j<20;j++)
		for(int k=0;k<20;k++)
			{	count=countNeighbors(j,k);

				// deal with the case where the cell was empty before the step
				if (! modelCurrent[j][k])
					{ if(count == 3)
						modelNext[j][k]=true;
						else
						modelNext[j][k]=false;
					}
				//  deal with the case where the cell was occupied before the step
				else
					{ if(count==3 || count==2)
						modelNext[j][k]=true;
						else
						modelNext[j][k]=false;
					}
			}	
	// create the squares array which is returned to the caller
	

	for (int jj=0;jj<20;jj++)
		for(int kk=0;kk<20;kk++)		
			{squareOut[jj*20+kk].setState(modelNext[jj][kk]);
			}					
			
		
	
		return squareOut;
	}

 /**
 *	clear resets all the elements of the cell model to false (i.e an  empty model)
 * @return An array of squares that represent the graphical view of the iterated model
 */
	public Square[] clear()
	{
	Square[] squareOut= new Square[400];
	for (int i=0;i<400;i++)
	squareOut[i]=new Square();
	
	return squareOut;
	}
	
 /**
 *	squareOut counts the number of neighbors in the cell model for the cell specified
 * @param i The row of the cell
 * @param j The column of the cell
 * @return  The number of neighbors
 */
	private int countNeighbors(int i , int j)
	{
		int numNeighbors =0;
		int caseNum=1;

		
		// identify whick of the 9 possible cases apply special cases are needed to claculate neighbors on the edges of the array
		// case 1 is top left corner of the array
		if(i==0 && j== 0)
			caseNum=1;
		// case 2 is top right corner of the array
		if(i==0&& j== 19)
			caseNum=2;
		// case 3 is bottom left corner of the array
		if(i==19&& j==0)
			caseNum=3;
		// case 4 is bottom right corner of the array
		if(i==19&& j==19)
			caseNum=4;
		// case 5 is all non-corner entries in the first row of the array
		if(i==0 && j>0 && j<19)
			{caseNum=5;
			}
		// case 6 is all non-corner entries in the last row of the array
		if(i==19 && j>0 && j<19)
			caseNum=6;
		// case 7 is all non-corner entries in the first column of the array
		if(j==0 && i>0 && i<19)
			caseNum=7;
		// case 8 is all non-corner entries in the last column of the array
		if(j==19 && i>0 && i<19)
			caseNum=8;
		// case 9 is all the entries in the interior of the array
		// the interior excludes all the cases above
		if(i<19 && i>0 && j<19 && j>0)
			caseNum=9;
			
		// for a cell (i,j) calculate the number of active (i.e occupied) neighbors
		// there is different logoc for each case

		switch (caseNum)
		{
		// case 9 is all the entries in the interior of the array
		// the interior excludes all the cases above		
		case 9:
		{	
			if(modelCurrent[i-1][j-1])
			numNeighbors+=1;
			if(modelCurrent[i][j-1])
			numNeighbors+=1;
			if(modelCurrent[i+1][j-1])
			numNeighbors+=1;
			if(modelCurrent[i-1][j])
			numNeighbors+=1;
			if(modelCurrent[i+1][j])
			numNeighbors+=1;
			if(modelCurrent[i-1][j+1])
			numNeighbors+=1;
			if(modelCurrent[i][j+1])
			numNeighbors+=1;
			if(modelCurrent[i+1][j+1])
			numNeighbors+=1;
				
			break;
								
		}
		// case 1 is top left corner of the array
		case 1:
		{	
			if(modelCurrent[i+1][j])
			numNeighbors+=1;
			if(modelCurrent[i][j+1])
			numNeighbors+=1;
			if(modelCurrent[i+1][j+1])
			numNeighbors+=1;
			
			
			break;	
						
		}
		// case 2 is top right corner of the array
		case 2:
		{	

			if(modelCurrent[i][j-1])
			numNeighbors+=1;
			if(modelCurrent[i+1][j-1])
			numNeighbors+=1;
			if(modelCurrent[i+1][j])
			numNeighbors+=1;
			
			break;
							
		}
		// case 3 is bottom left corner of the array
		case 3:
		{	
			if(modelCurrent[i-1][j])
			numNeighbors+=1;
			if(modelCurrent[i-1][j+1])
			numNeighbors+=1;
			if(modelCurrent[i][j+1])
			numNeighbors+=1;
			
			break;
							
		}
		// case 4 is bottom right corner of the array
		case 4:
		{	
			if(modelCurrent[i-1][j-1])
			numNeighbors+=1;
			if(modelCurrent[i][j-1])
			numNeighbors+=1;
			if(modelCurrent[i-1][j])
			numNeighbors+=1;
			break;
			
								
		}
		// case 5 is all non-corner entries in the first row of the array
		case 5:
		{	
			if(modelCurrent[i][j-1])
			numNeighbors+=1;
			if(modelCurrent[i+1][j-1])
			numNeighbors+=1;
			if(modelCurrent[i+1][j])
			numNeighbors+=1;
			if(modelCurrent[i][j+1])
			numNeighbors+=1;
			if(modelCurrent[i+1][j+1])
			numNeighbors+=1;
			
			break;
									
		}
		// case 6 is all non-corner entries in the last row of the array
		case 6:
		{	
			if(modelCurrent[i-1][j-1])
			numNeighbors+=1;
			if(modelCurrent[i][j-1])
			numNeighbors+=1;
			if(modelCurrent[i-1][j])
			numNeighbors+=1;
			if(modelCurrent[i-1][j+1])
			numNeighbors+=1;
			if(modelCurrent[i][j+1])
			numNeighbors+=1;
			
			break;
									
		}
		// case 7 is all non-corner entries in the first column of the array
		case 7:
		{	
			if(modelCurrent[i-1][j])
			numNeighbors+=1;
			if(modelCurrent[i+1][j])
			numNeighbors+=1;
			if(modelCurrent[i-1][j+1])
			numNeighbors+=1;
			if(modelCurrent[i][j+1])
			numNeighbors+=1;
			if(modelCurrent[i+1][j+1])
			numNeighbors+=1;
			
			break;
									
		}
		case 8:
		// case 8 is all non-corner entries in the last column of the array
		{	
			if(modelCurrent[i-1][j-1])
			numNeighbors+=1;
			if(modelCurrent[i][j-1])
			numNeighbors+=1;
			if(modelCurrent[i+1][j-1])
			numNeighbors+=1;
			if(modelCurrent[i-1][j])
			numNeighbors+=1;
			if(modelCurrent[i+1][j])
			numNeighbors+=1;
			break;
			
						
		}

		}
		
						
		return numNeighbors;			
			
	}
		
		
	
	
	
	
	
	
	
	
}
	